<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );

class ps_billing {

    var $classname = "ps_billing";
    var $payment_code = "BL";

function show_configuration() {
	global $VM_LANG;
	$db = new ps_DB();
	include_once(CLASSPATH ."payment/".$this->classname.".cfg.php"); // Read current Configuration
	
    ?>
<table>
	<tr>
		<td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_PAYMENT_ORDERSTATUS_SUCC') ?></strong></td>
		<td>
			<select name="BILLING_VERIFIED_STATUS" class="inputbox" >
			<?php
				$q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
				$db->query($q);
				$order_status_code = Array();
				$order_status_name = Array();
				
				while ($db->next_record()) {
					$order_status_code[] = $db->f("order_status_code");
					$order_status_name[] = $db->f("order_status_name");
				}
				
				for ($i = 0; $i < sizeof($order_status_code); $i++) {
					echo "<option value=\"" . $order_status_code[$i];
					if (BILLING_VERIFIED_STATUS == $order_status_code[$i]) 
						echo "\" selected=\"selected\">";
					else
						echo "\">";
						echo $order_status_name[$i] . "</option>\n";
				}?>
			</select>
		</td>
		<td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_PAYMENT_ORDERSTATUS_SUCC_EXPLAIN') ?></td>
	</tr>
	
	<tr>
		<td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_PAYMENT_ORDERSTATUS_FAIL') ?></strong></td>
		<td>
			<select name="BILLING_INVALID_STATUS" class="inputbox" >
			<?php
				for ($i = 0; $i < sizeof($order_status_code); $i++) {
					echo "<option value=\"" . $order_status_code[$i];
					if (BILLING_INVALID_STATUS == $order_status_code[$i]) 
						echo "\" selected=\"selected\">";
					else
						echo "\">";
						echo $order_status_name[$i] . "</option>\n";
			} ?>
			</select>
		</td>
		<td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_PAYMENT_ORDERSTATUS_FAIL_EXPLAIN') ?></td>
	</tr>
	<tr>
		<td><strong>Описание платежа</strong></td>
		<td><input type="text" name="BILLING_PAYMENT_DESC" class="inputbox" value="<?  echo BILLING_PAYMENT_DESC ?>" /></td>
		<td></td>
	</tr>
</table>
<?php
}
    
function has_configuration() {
	// return false if there's no configuration
	return true;
}
   
  /**
	* Returns the "is_writeable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
function configfile_writeable() {
	return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
}
   
  /**
	* Returns the "is_readable" status of the configuration file
	* @param void
	* @returns boolean True when the configuration file is writeable, false when not
	*/
function configfile_readable() {
	return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
}
   
  /**
	* Writes the configuration file for this payment method
	* @param array An array of objects
	* @returns boolean True when writing was successful
	*/
function write_configuration( &$d ) {
	$my_config_array = array(	
								"BILLING_VERIFIED_STATUS" 	=> $d['BILLING_VERIFIED_STATUS'],
								"BILLING_INVALID_STATUS"	=> $d['BILLING_INVALID_STATUS'],
								"BILLING_PENDING_STATUS"	=> $d['BILLING_PENDING_STATUS'],
								"BILLING_PAYMENT_DESC"			=> $d['BILLING_PAYMENT_DESC']
                            );
	$config = "<?php\n";
	$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
	foreach( $my_config_array as $key => $value ) {
		$config .= "define ('$key', '$value');\n";
	}
	$config .= "?>";
  
	if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
		fputs($fp, $config, strlen($config));
		fclose ($fp);
		return true;
	}
	else
		return false;
}
   
  /**************************************************************************
  ** name: process_payment()
  ** returns: 
  ***************************************************************************/
function process_payment($order_number, $order_total, &$d) 
	{
  		$user = JFactory::getUser();
		$uid = $user->id;
		
		if ($uid == 0)
		{
			echo 'Вы должны войти на сайт для осуществления оплаты с личного счета.';
		}
		
		require_once( JPATH_BASE .DS.'components'.DS.'com_billing'.DS.'useraccount.php');
		require_once( JPATH_BASE .DS.'components'.DS.'com_billing'.DS.'account.php' );

		// проверяем баланс пользователя
		$UA = new UserAccount;
		$b = $UA->GetBalanceEx($uid, 0);//

		if ($order_total > $b)
		{
			$amount = $order_total - $b;
			echo "<p>На вашем счете не хватает денег для оплаты. <a href='index.php?option=com_billing&view=pay&sum=$amount'>Пополнить счет на ".FormatDefaultCurrency($amount)."</a></p>";
			$d['new_order_status'] = BILLING_INVALID_STATUS;
			$d['order_status'] = BILLING_INVALID_STATUS;
			return true;
		}
		else
		{

			include_once(CLASSPATH ."payment/".$this->classname.".cfg.php"); // Read current Configuration
		
			$pid = date('ymdhis') . $uid;
			$UA->WithdrawMoney($uid, $order_total, $pid, "Оплата заказа ID: $order_number");
			
			$d['new_order_status'] = BILLING_VERIFIED_STATUS;
			$d['order_status'] = BILLING_VERIFIED_STATUS;
			
/*			$query = "update `#__{vm}_orders` set order_status = '".BILLING_VERIFIED_STATUS."' WHERE `order_number`='".$order_number."'";
			$db->setQuery($query);
			$db->query();*/
		}
	  
	  return true;
    }
   
}